/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// Advertiser object for NHibernate mapped table 'Advertiser'.
	/// </summary>
	[Serializable]
	public class Advertiser
	{
		#region Member Variables
		protected long _id;
		protected string _displayname;
		protected string _fullname;
		protected string _email;
		protected string _password;
		protected string _promocode;
		protected string _referrer;
		protected DateTime _createddate;
		protected DateTime? _lastupdated;
		protected bool? _active;
		protected IList<AdvertiserBonusProgram> _advertiserbonusprogram;
		protected IList<Campaign> _campaign;
		protected IList<CampaignFund> _campaignfund;
		#endregion
		#region Constructors
			
		public Advertiser() {}
					
		public Advertiser(string displayname, string fullname, string email, string password, string promocode, string referrer, DateTime createddate, DateTime? lastupdated, bool? active) 
		{
			this._displayname= displayname;
			this._fullname= fullname;
			this._email= email;
			this._password= password;
			this._promocode= promocode;
			this._referrer= referrer;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
			this._active= active;
		}

		public Advertiser(string displayname, string fullname, string email, string password, DateTime createddate)
		{
			this._displayname= displayname;
			this._fullname= fullname;
			this._email= email;
			this._password= password;
			this._createddate= createddate;
		}
		
		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string DisplayName
		{
			get { return _displayname; }
			set {_displayname= value; }
		}
		public  virtual string FullName
		{
			get { return _fullname; }
			set {_fullname= value; }
		}
		public  virtual string Email
		{
			get { return _email; }
			set {_email= value; }
		}
		public  virtual string Password
		{
			get { return _password; }
			set {_password= value; }
		}
		public  virtual string Promocode
		{
			get { return _promocode; }
			set {_promocode= value; }
		}
		public  virtual string Referrer
		{
			get { return _referrer; }
			set {_referrer= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public  virtual bool? Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<AdvertiserBonusProgram> AdvertiserBonusProgram
		{
			get { return _advertiserbonusprogram; }
			set {_advertiserbonusprogram= value; }
		}
		public  virtual IList<Campaign> Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		public  virtual IList<CampaignFund> CampaignFund
		{
			get { return _campaignfund; }
			set {_campaignfund= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			Advertiser castObj = (Advertiser)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
