/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// AdvertiserFunds object for NHibernate mapped table 'Advertiser_Funds'.
	/// </summary>
	[Serializable]
	public class AdvertiserFunds
	{
		#region Member Variables
		protected long _id;
		protected long _advertiserid;
		protected PaymentInfo _paymentinfo;
		protected TransType _transtype;
		protected DateTime _transdate;
		protected decimal _transamount;
		protected decimal _balance;
		protected string _remarks;
		#endregion
		#region Constructors
			
		public AdvertiserFunds() {}
					
		public AdvertiserFunds(long advertiserid, PaymentInfo paymentinfo, TransType transtype, DateTime transdate, decimal transamount, decimal balance, string remarks) 
		{
			this._advertiserid= advertiserid;
			this._paymentinfo= paymentinfo;
			this._transtype= transtype;
			this._transdate= transdate;
			this._transamount= transamount;
			this._balance= balance;
			this._remarks= remarks;
		}

		public AdvertiserFunds(long advertiserid, PaymentInfo paymentinfo, TransType transtype, DateTime transdate, decimal transamount, decimal balance)
		{
			this._advertiserid= advertiserid;
			this._paymentinfo= paymentinfo;
			this._transtype= transtype;
			this._transdate= transdate;
			this._transamount= transamount;
			this._balance= balance;
		}
		
		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual long Advertiserid
		{
			get { return _advertiserid; }
			set {_advertiserid= value; }
		}
		public  virtual PaymentInfo PaymentInfo
		{
			get { return _paymentinfo; }
			set {_paymentinfo= value; }
		}
		public  virtual TransType TransType
		{
			get { return _transtype; }
			set {_transtype= value; }
		}
		public  virtual DateTime TransDate
		{
			get { return _transdate; }
			set {_transdate= value; }
		}
		public  virtual decimal TransAmount
		{
			get { return _transamount; }
			set {_transamount= value; }
		}
		public  virtual decimal Balance
		{
			get { return _balance; }
			set {_balance= value; }
		}
		public  virtual string Remarks
		{
			get { return _remarks; }
			set {_remarks= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			AdvertiserFunds castObj = (AdvertiserFunds)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
