/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// BonusProgram object for NHibernate mapped table 'Bonus_Program'.
	/// </summary>
	[Serializable]
	public class BonusProgram
	{
		#region Member Variables
		protected int _id;
		protected int _commitmentmonths;
		protected int _mincommitmentmonths;
		protected decimal _monthlyamount;
		protected decimal _percentage;
		protected DateTime _createddate;
		protected bool _active;
		protected IList<AdvertiserBonusProgram> _advertiserbonusprogram;
		#endregion
		#region Constructors
			
		public BonusProgram() {}
					
		public BonusProgram(int commitmentmonths, int mincommitmentmonths, decimal monthlyamount, decimal percentage, DateTime createddate, bool active) 
		{
			this._commitmentmonths= commitmentmonths;
			this._mincommitmentmonths= mincommitmentmonths;
			this._monthlyamount= monthlyamount;
			this._percentage= percentage;
			this._createddate= createddate;
			this._active= active;
		}

		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual int CommitmentMonths
		{
			get { return _commitmentmonths; }
			set {_commitmentmonths= value; }
		}
		public  virtual int MinCommitmentMonths
		{
			get { return _mincommitmentmonths; }
			set {_mincommitmentmonths= value; }
		}
		public  virtual decimal MonthlyAmount
		{
			get { return _monthlyamount; }
			set {_monthlyamount= value; }
		}
		public  virtual decimal Percentage
		{
			get { return _percentage; }
			set {_percentage= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual bool Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<AdvertiserBonusProgram> AdvertiserBonusProgram
		{
			get { return _advertiserbonusprogram; }
			set {_advertiserbonusprogram= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			BonusProgram castObj = (BonusProgram)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
