/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;
using SND.Model.Publishers;
using SND.Model.Shared;

namespace SND.Model.Campaigns
{
	/// <summary>
	/// Campaign object for NHibernate mapped table 'Campaign'.
	/// </summary>
	[Serializable]
	public class Campaign : BaseEntity
	{
		#region Member Variables
		private long _id;
		private string _title;
		private string _url;
		private string _message;
		private bool? _googleAnalytics;
		private decimal _budget;
		private decimal _minbalance;
		private decimal _costPerClick;
		private int _minFollowers;
		private bool? _autoApprove;
		private DateTime _createdDate;
		private DateTime? _lastUpdated;
		private bool? _active;
		private string _adminComments;
		private int? _cancelTwitterUser;
        private Advertiser _owner;
        private IList<CampaignPublisher> _campaignPublishers;



        //private PaymentInfo _paymentinfo;
        //private PaymentStatus _paymentstatus;
        //private CampaignStatus _campaignstatus;


        //private IList<CampaignAccount> _campaignaccount;
        //private IList<CampaignAcctLocation> _campaignacctlocation;
        //private IList<CampaignAcctTag> _campaignaccttag;
        //private IList<CampaignFund> _campaignfund;
        //private IList<CampaignPublisher> _campaignpublisher;
        //private IList<CampaignPublisherResponse> _campaignpublisherresponse;
		#endregion
		#region Constructors
			
		public Campaign() {}
					
		public Campaign(string title, string url, string message, bool? googleanalytics, decimal budget, decimal minbalance, decimal costperclick, int minfollowers, bool? autoapprove) 
		{
	     	this._title= title;
			this._url= url;
			this._message= message;
			this._googleAnalytics= googleanalytics;
			this._budget= budget;
			this._minbalance= minbalance;
			this.CostPerClick= costperclick;
            this._minFollowers = minfollowers;
			this._autoApprove= autoapprove;
            _campaignPublishers = new List<CampaignPublisher>();
		}

				
		#endregion
		#region Public Properties
		public   long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  Advertiser Owner
		{
			get { return _owner; }
            set { _owner = value; }
		}
		public   string Title
		{
			get { return _title; }
			set {_title= value; }
		}
		public   string Url
		{
			get { return _url; }
			set {_url= value; }
		}
		public   string Message
		{
			get { return _message; }
			set {_message= value; }
		}
		public   bool? GoogleAnalytics
		{
			get { return _googleAnalytics; }
			set {_googleAnalytics= value; }
		}
		public   decimal Budget
		{
			get { return _budget; }
			set {_budget= value; }
		}
		public   decimal MinBalance
		{
			get { return _minbalance; }
			set {_minbalance= value; }
		}
		public   decimal CostPerClick
		{
            get { return _costPerClick; }
            set { _costPerClick = value; }
		}
		public   int MinFollowers
		{
			get { return _minFollowers; }
			set {_minFollowers= value; }
		}
		public   bool? AutoApprove
		{
			get { return _autoApprove; }
			set {_autoApprove= value; }
		}
		public   DateTime CreatedDate
		{
			get { return _createdDate; }
			set {_createdDate= value; }
		}
		public   DateTime? LastUpdated
		{
			get { return _lastUpdated; }
			set {_lastUpdated= value; }
		}
		public   bool? Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public   string AdminComments
		{
			get { return _adminComments; }
			set {_adminComments= value; }
		}
		public  CampaignStatus CampaignStatus
		{
			get { return _campaignstatus; }
			set {_campaignstatus= value; }
		}
		public   int? CancelTwitterUser
		{
			get { return _cancelTwitterUser; }
			set {_cancelTwitterUser= value; }
		}
		public   PaymentInfo PaymentInfo
		{
			get { return _paymentinfo; }
			set {_paymentinfo= value; }
		}
		public   PaymentStatus PaymentStatus
		{
			get { return _paymentstatus; }
			set {_paymentstatus= value; }
		}
		public   IList<CampaignAccount> CampaignAccount
		{
			get { return _campaignaccount; }
			set {_campaignaccount= value; }
		}
		public   IList<CampaignAcctLocation> CampaignAcctLocation
		{
			get { return _campaignacctlocation; }
			set {_campaignacctlocation= value; }
		}
		public   IList<CampaignAcctTag> CampaignAcctTag
		{
			get { return _campaignaccttag; }
			set {_campaignaccttag= value; }
		}
		public   IList<CampaignFund> CampaignFund
		{
			get { return _campaignfund; }
			set {_campaignfund= value; }
		}
		public   IList<CampaignPublisher> CampaignPublishers
		{
			get { return _campaignPublishers; }
			set {_campaignPublishers= value; }
		}
		public   IList<CampaignPublisherResponse> CampaignPublisherResponse
		{
			get { return _campaignpublisherresponse; }
			set {_campaignpublisherresponse= value; }
		}
		#endregion

        #region Public Methods

        public void Assign(CampaignPublisher campaignPublisher)
        {
            this._campaignPublishers.Add(campaignPublisher);
        }

        #endregion


        #region Equals And HashCode Overrides
        /// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			Campaign castObj = (Campaign)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
