/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// CampaignAccount object for NHibernate mapped table 'Campaign_Account'.
	/// </summary>
	[Serializable]
	public class CampaignAccount
	{
		#region Member Variables
		protected long _id;
		protected Campaign _campaign;
		protected SocialAccount _account;
		protected decimal _commissionamount;
		#endregion
		#region Constructors
			
		public CampaignAccount() {}
					
		public CampaignAccount(Campaign campaign, SocialAccount account, decimal commissionamount) 
		{
			this._campaign= campaign;
			this._account= account;
			this._commissionamount= commissionamount;
		}

		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual Campaign Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		public  virtual SocialAccount Account
		{
			get { return _account; }
			set {_account= value; }
		}
		public  virtual decimal CommissionAmount
		{
			get { return _commissionamount; }
			set {_commissionamount= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			CampaignAccount castObj = (CampaignAccount)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
