/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// CampaignAcctTag object for NHibernate mapped table 'Campaign_Acct_Tag'.
	/// </summary>
	[Serializable]
	public class CampaignAcctTag
	{
		#region Member Variables
		protected long _id;
		protected SocialAccount _account;
		protected Campaign _campaign;
		protected MasterTags _mastertags;
		#endregion
		#region Constructors
			
		public CampaignAcctTag() {}
					
		public CampaignAcctTag(SocialAccount account, Campaign campaign, MasterTags mastertags) 
		{
			this._account= account;
			this._campaign= campaign;
			this._mastertags= mastertags;
		}

		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual SocialAccount Account
		{
			get { return _account; }
			set {_account= value; }
		}
		public  virtual Campaign Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		public  virtual MasterTags MasterTags
		{
			get { return _mastertags; }
			set {_mastertags= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			CampaignAcctTag castObj = (CampaignAcctTag)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
