/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// CampaignFund object for NHibernate mapped table 'Campaign_Fund'.
	/// </summary>
	[Serializable]
	public class CampaignFund
	{
		#region Member Variables
		protected long _id;
		protected Campaign _campaign;
		protected Advertiser _advertiser;
		protected decimal _transferamount;
		protected int _totalclicks;
		protected string _remarks;
		protected DateTime _transferdate;
		#endregion
		#region Constructors
			
		public CampaignFund() {}
					
		public CampaignFund(Campaign campaign, Advertiser advertiser, decimal transferamount, int totalclicks, string remarks, DateTime transferdate) 
		{
			this._campaign= campaign;
			this._advertiser= advertiser;
			this._transferamount= transferamount;
			this._totalclicks= totalclicks;
			this._remarks= remarks;
			this._transferdate= transferdate;
		}

		public CampaignFund(Campaign campaign, Advertiser advertiser, decimal transferamount, int totalclicks, DateTime transferdate)
		{
			this._campaign= campaign;
			this._advertiser= advertiser;
			this._transferamount= transferamount;
			this._totalclicks= totalclicks;
			this._transferdate= transferdate;
		}
		
		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual Campaign Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		public  virtual Advertiser Advertiser
		{
			get { return _advertiser; }
			set {_advertiser= value; }
		}
		public  virtual decimal TransferAmount
		{
			get { return _transferamount; }
			set {_transferamount= value; }
		}
		public  virtual int TotalClicks
		{
			get { return _totalclicks; }
			set {_totalclicks= value; }
		}
		public  virtual string Remarks
		{
			get { return _remarks; }
			set {_remarks= value; }
		}
		public  virtual DateTime TransferDate
		{
			get { return _transferdate; }
			set {_transferdate= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			CampaignFund castObj = (CampaignFund)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
