/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// CampaignPublisherResponse object for NHibernate mapped table 'Campaign_Publisher_Response'.
	/// </summary>
	[Serializable]
	public class CampaignPublisherResponse
	{
		#region Member Variables
		protected long _id;
		protected Campaign _campaign;
		protected SocialAccount _account;
		protected Publisher _publisher;
		protected string _ipaddress;
		protected DateTime _createddate;
		protected MasterInvalidReasons _masterinvalidreasons;
		protected int _validcount;
		#endregion
		#region Constructors
			
		public CampaignPublisherResponse() {}
					
		public CampaignPublisherResponse(long id, Campaign campaign, SocialAccount account, Publisher publisher, string ipaddress, DateTime createddate, int validcount) 
		{
			this._id= id;
			this._campaign= campaign;
			this._account= account;
			this._publisher= publisher;
			this._ipaddress= ipaddress;
			this._createddate= createddate;
			this._validcount= validcount;
		}

		public CampaignPublisherResponse(long id, Campaign campaign, SocialAccount account, Publisher publisher, string ipaddress, DateTime createddate)
		{
			this._id= id;
			this._campaign= campaign;
			this._account= account;
			this._publisher= publisher;
			this._ipaddress= ipaddress;
			this._createddate= createddate;
		}
		
		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual Campaign Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		public  virtual SocialAccount Account
		{
			get { return _account; }
			set {_account= value; }
		}
		public  virtual Publisher Publisher
		{
			get { return _publisher; }
			set {_publisher= value; }
		}
		public  virtual string IpAddress
		{
			get { return _ipaddress; }
			set {_ipaddress= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual MasterInvalidReasons MasterInvalidReasons
		{
			get { return _masterinvalidreasons; }
			set {_masterinvalidreasons= value; }
		}
		public  virtual int ValidCount
		{
			get { return _validcount; }
			set {_validcount= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			CampaignPublisherResponse castObj = (CampaignPublisherResponse)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
