/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// CampaignStatus object for NHibernate mapped table 'CampaignStatus'.
	/// </summary>
	[Serializable]
	public class CampaignStatus
	{
		#region Member Variables
		protected int _id;
		protected string _statusname;
		protected string _description;
		protected bool? _active;
		protected DateTime? _createddate;
		protected DateTime? _lastupdated;
		protected IList<Campaign> _campaign;
		#endregion
		#region Constructors
			
		public CampaignStatus() {}
					
		public CampaignStatus(string statusname, string description, bool? active, DateTime? createddate, DateTime? lastupdated) 
		{
			this._statusname= statusname;
			this._description= description;
			this._active= active;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
		}

		public CampaignStatus(string statusname, string description)
		{
			this._statusname= statusname;
			this._description= description;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string StatusName
		{
			get { return _statusname; }
			set {_statusname= value; }
		}
		public  virtual string Description
		{
			get { return _description; }
			set {_description= value; }
		}
		public  virtual bool? Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual DateTime? CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public  virtual IList<Campaign> Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			CampaignStatus castObj = (CampaignStatus)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
