/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;
using SND.Model.Shared;
using SND.Model.Campaigns;

namespace SND.Model.Publishers
{
	/// <summary>
	/// Publisher object for NHibernate mapped table 'Publisher'.
	/// </summary>
	[Serializable]
	public class Publisher : BaseEntity
	{
		#region Member Variables
        private long _id;
		private string _name;
		private string _email;
		private string _password;
		private decimal _balance;
		private DateTime _createddate;
		private DateTime? _lastupdated;
		private bool? _active;

        private CampaignPublisher _campaignPublisher;

        private IList<PublisherSocialAccount> _publisherSocialAccounts;
     

        //private IList<CampaignPublisher> _campaignpublisher;
        //private IList<CampaignPublisherResponse> _campaignpublisherresponse;
        //private IList<PublisherReferrer> _publisherreferrer;
        //private IList<PublisherReferrer> _publisherreferred;
        //private IList<PublisherWithdraw> _publisherwithdraw;
		#endregion
		#region Constructors
			
		public Publisher() {}
					
		public Publisher(string name, string email, string password, decimal balance, DateTime createddate, DateTime? lastupdated, bool? active)
		{
			this._name= name;
			this._email= email;
			this._password= password;
			this._balance= balance;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
			this._active= active;
            this._publisherSocialAccounts=new List<PublisherSocialAccount>();
		}

		public Publisher(string name, string email, string password, decimal balance, DateTime createddate) : this(name, email, password,  balance,  createddate, null,null)
		{
			
		}
		
		#endregion
		#region Public Properties
		public   long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public   string Name
		{
			get { return _name; }
			set {_name= value; }
		}
		public   string Email
		{
			get { return _email; }
			set {_email= value; }
		}
		public   string Password
		{
			get { return _password; }
			set {_password= value; }
		}
		public   decimal Balance
		{
			get { return _balance; }
			set {_balance= value; }
		}
		public   DateTime CreatedDate
		{
			get { return _createddate; }

		}
		public   DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public   bool? Active
		{
			get { return _active; }
			set {_active= value; }
		}
        public  CampaignPublisher CampaignPublisher
        {
            get { return _campaignPublisher; }
            set { _campaignPublisher = value; }
        }

        public IList<PublisherSocialAccount> Assign
        {
            get { return _publisherSocialAccounts; }
            set { _publisherSocialAccounts = value; }
        }

        //public   IList<CampaignPublisher> CampaignPublisher
        //{
        //    get { return _campaignpublisher; }
        //    set {_campaignpublisher= value; }
        //}
        //public   IList<CampaignPublisherResponse> CampaignPublisherResponse
        //{
        //    get { return _campaignpublisherresponse; }
        //    set {_campaignpublisherresponse= value; }
        //}
        //public   IList<PublisherReferrer> PublisherReferrer
        //{
        //    get { return _publisherreferrer; }
        //    set {_publisherreferrer= value; }
        //}
        //public  IList<PublisherReferrer> Publisherreferred
        //{
        //    get { return _publisherreferred; }
        //    set {_publisherreferred= value; }
        //}
		#endregion

        #region Public Methods
        public void Assign(PublisherSocialAccount publisherSocialAccount)
        {
            _publisherSocialAccounts.Add(publisherSocialAccount);
        }

        #endregion




    }
}
