/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model.Publishers
{
	/// <summary>
	/// PublisherReferralOffer object for NHibernate mapped table 'Publisher_Referral_Offer'.
	/// </summary>
	[Serializable]
	public class PublisherReferralOffer 
	{
		#region Member Variables
		protected int _id;
		protected decimal _percentperclick;
		protected int _percentperiod;
		protected DateTime _createddate;
		protected bool _active;
		protected IList<PublisherReferrer> _publisherreferrer;
		#endregion
		#region Constructors
			
		public PublisherReferralOffer() {}
					
		public PublisherReferralOffer(decimal percentperclick, int percentperiod, DateTime createddate, bool active) 
		{
			this._percentperclick= percentperclick;
			this._percentperiod= percentperiod;
			this._createddate= createddate;
			this._active= active;
		}

		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual decimal PercentPerClick
		{
			get { return _percentperclick; }
			set {_percentperclick= value; }
		}
		public  virtual int PercentPeriod
		{
			get { return _percentperiod; }
			set {_percentperiod= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual bool Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<PublisherReferrer> PublisherReferrer
		{
			get { return _publisherreferrer; }
			set {_publisherreferrer= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			PublisherReferralOffer castObj = (PublisherReferralOffer)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
