/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model.Publishers
{
	/// <summary>
	/// PublisherWithdraw object for NHibernate mapped table 'Publisher_Withdraw'.
	/// </summary>
	[Serializable]
	public class PublisherWithdraw
	{
		#region Member Variables
		protected long _id;
		protected long _publisherid;
		protected decimal _amountwithdrawl;
		protected WithdrawlMethod _withdrawlmethod;
		protected WithdrawStatus _withdrawstatus;
		protected string _remarks;
		protected DateTime _createddate;
		#endregion
		#region Constructors
			
		public PublisherWithdraw() {}
					
		public PublisherWithdraw(long publisherid, decimal amountwithdrawl, WithdrawlMethod withdrawlmethod, WithdrawStatus withdrawstatus, string remarks, DateTime createddate) 
		{
			this._publisherid= publisherid;
			this._amountwithdrawl= amountwithdrawl;
			this._withdrawlmethod= withdrawlmethod;
			this._withdrawstatus= withdrawstatus;
			this._remarks= remarks;
			this._createddate= createddate;
		}

		public PublisherWithdraw(long publisherid, decimal amountwithdrawl, WithdrawlMethod withdrawlmethod, WithdrawStatus withdrawstatus, DateTime createddate)
		{
			this._publisherid= publisherid;
			this._amountwithdrawl= amountwithdrawl;
			this._withdrawlmethod= withdrawlmethod;
			this._withdrawstatus= withdrawstatus;
			this._createddate= createddate;
		}
		
		#endregion
		#region Public Properties
		public  virtual long Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual long Publisherid
		{
			get { return _publisherid; }
			set {_publisherid= value; }
		}
		public  virtual decimal AmountWithdrawl
		{
			get { return _amountwithdrawl; }
			set {_amountwithdrawl= value; }
		}
		public  virtual WithdrawlMethod WithdrawlMethod
		{
			get { return _withdrawlmethod; }
			set {_withdrawlmethod= value; }
		}
		public  virtual WithdrawStatus WithdrawStatus
		{
			get { return _withdrawstatus; }
			set {_withdrawstatus= value; }
		}
		public  virtual string Remarks
		{
			get { return _remarks; }
			set {_remarks= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			PublisherWithdraw castObj = (PublisherWithdraw)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
