﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace SND.Model.Shared
{
    /// <summary>
    /// Provides a base class for entities
    /// </summary>
    /// 

    public abstract partial class BaseEntity
    {
        private object key;

        public BaseEntity():this(null){}
       
        public BaseEntity(object key)
        {
            this.key = key;
        }

        #region Equals And HashCode Overrides
        /// <summary>
        /// local implementation of Equals based on unique value members
        /// </summary>
        public override bool Equals(object obj)
        {

            if ((obj == null) || (obj.GetType() != this.GetType())) return false;
            return (this == (BaseEntity)obj);
        }
        /// <summary>
        /// local implementation of GetHashCode based on unique value members
        /// </summary>
        public override int GetHashCode()
        {
            int hash = 57;
            hash = 27 * hash * this.key.GetHashCode();
            return hash;
        }
        #endregion
    }
}
