/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// Country object for NHibernate mapped table 'Country'.
	/// </summary>
	[Serializable]
	public class Country
	{
		#region Member Variables
		protected int _idcountry;
		protected string _name;
		protected bool _allowsregistration;
		protected bool _allowsbilling;
		protected bool _allowsshipping;
		protected string _twoletterisocode;
		protected string _threeletterisocode;
		protected int _numericisocode;
		protected bool _subjecttovat;
		protected bool _published;
		protected int _displayorder;
		protected IList<PaymentMethodRestrictedCountries> _paymentmethodrestrictedcountries;
		#endregion
		#region Constructors
			
		public Country() {}
					
		public Country(string name, bool allowsregistration, bool allowsbilling, bool allowsshipping, string twoletterisocode, string threeletterisocode, int numericisocode, bool subjecttovat, bool published, int displayorder) 
		{
			this._name= name;
			this._allowsregistration= allowsregistration;
			this._allowsbilling= allowsbilling;
			this._allowsshipping= allowsshipping;
			this._twoletterisocode= twoletterisocode;
			this._threeletterisocode= threeletterisocode;
			this._numericisocode= numericisocode;
			this._subjecttovat= subjecttovat;
			this._published= published;
			this._displayorder= displayorder;
		}

		public Country(string name, bool allowsregistration, bool allowsbilling, bool allowsshipping, string twoletterisocode, string threeletterisocode, int numericisocode, bool published)
		{
			this._name= name;
			this._allowsregistration= allowsregistration;
			this._allowsbilling= allowsbilling;
			this._allowsshipping= allowsshipping;
			this._twoletterisocode= twoletterisocode;
			this._threeletterisocode= threeletterisocode;
			this._numericisocode= numericisocode;
			this._published= published;
		}
		
		#endregion
		#region Public Properties
		public  virtual int IdCountry
		{
			get { return _idcountry; }
			set {_idcountry= value; }
		}
		public  virtual string Name
		{
			get { return _name; }
			set {_name= value; }
		}
		public  virtual bool AllowsRegistration
		{
			get { return _allowsregistration; }
			set {_allowsregistration= value; }
		}
		public  virtual bool AllowsBilling
		{
			get { return _allowsbilling; }
			set {_allowsbilling= value; }
		}
		public  virtual bool AllowsShipping
		{
			get { return _allowsshipping; }
			set {_allowsshipping= value; }
		}
		public  virtual string TwoLetterisoCode
		{
			get { return _twoletterisocode; }
			set {_twoletterisocode= value; }
		}
		public  virtual string ThreeLetterisoCode
		{
			get { return _threeletterisocode; }
			set {_threeletterisocode= value; }
		}
		public  virtual int NumericisoCode
		{
			get { return _numericisocode; }
			set {_numericisocode= value; }
		}
		public  virtual bool SubjectTovat
		{
			get { return _subjecttovat; }
			set {_subjecttovat= value; }
		}
		public  virtual bool Published
		{
			get { return _published; }
			set {_published= value; }
		}
		public  virtual int DisplayOrder
		{
			get { return _displayorder; }
			set {_displayorder= value; }
		}
		public  virtual IList<PaymentMethodRestrictedCountries> PaymentMethodRestrictedCountries
		{
			get { return _paymentmethodrestrictedcountries; }
			set {_paymentmethodrestrictedcountries= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			Country castObj = (Country)obj;
			return ( castObj != null ) &&
			this._idcountry == castObj.IdCountry;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _idcountry.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
