/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// CreditCardType object for NHibernate mapped table 'CreditCardType'.
	/// </summary>
	[Serializable]
	public class CreditCardType
	{
		#region Member Variables
		protected int _idcreditcardtype;
		protected string _name;
		protected string _systemkeyword;
		protected int _displayorder;
		protected bool _deleted;
		protected IList<PaymentInfo> _paymentinfo;
		#endregion
		#region Constructors
			
		public CreditCardType() {}
					
		public CreditCardType(string name, string systemkeyword, int displayorder, bool deleted) 
		{
			this._name= name;
			this._systemkeyword= systemkeyword;
			this._displayorder= displayorder;
			this._deleted= deleted;
		}

		#endregion
		#region Public Properties
		public  virtual int IdCreditCardType
		{
			get { return _idcreditcardtype; }
			set {_idcreditcardtype= value; }
		}
		public  virtual string Name
		{
			get { return _name; }
			set {_name= value; }
		}
		public  virtual string SystemKeyword
		{
			get { return _systemkeyword; }
			set {_systemkeyword= value; }
		}
		public  virtual int DisplayOrder
		{
			get { return _displayorder; }
			set {_displayorder= value; }
		}
		public  virtual bool Deleted
		{
			get { return _deleted; }
			set {_deleted= value; }
		}
		public  virtual IList<PaymentInfo> PaymentInfo
		{
			get { return _paymentinfo; }
			set {_paymentinfo= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			CreditCardType castObj = (CreditCardType)obj;
			return ( castObj != null ) &&
			this._idcreditcardtype == castObj.IdCreditCardType;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _idcreditcardtype.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
