/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// Language object for NHibernate mapped table 'Language'.
	/// </summary>
	[Serializable]
	public class Language
	{
		#region Member Variables
		protected int _languageid;
		protected string _name;
		protected string _languageculture;
		protected string _flagimagefilename;
		protected bool _published;
		protected int _displayorder;
		protected IList<LocaleStringResource> _localestringresource;
		#endregion
		#region Constructors
			
		public Language() {}
					
		public Language(string name, string languageculture, string flagimagefilename, bool published, int displayorder) 
		{
			this._name= name;
			this._languageculture= languageculture;
			this._flagimagefilename= flagimagefilename;
			this._published= published;
			this._displayorder= displayorder;
		}

		public Language(string name, string languageculture, bool published, int displayorder)
		{
			this._name= name;
			this._languageculture= languageculture;
			this._published= published;
			this._displayorder= displayorder;
		}
		
		#endregion
		#region Public Properties
		public  virtual int LanguageId
		{
			get { return _languageid; }
			set {_languageid= value; }
		}
		public  virtual string Name
		{
			get { return _name; }
			set {_name= value; }
		}
		public  virtual string LanguageCulture
		{
			get { return _languageculture; }
			set {_languageculture= value; }
		}
		public  virtual string FlagImageFileName
		{
			get { return _flagimagefilename; }
			set {_flagimagefilename= value; }
		}
		public  virtual bool Published
		{
			get { return _published; }
			set {_published= value; }
		}
		public  virtual int DisplayOrder
		{
			get { return _displayorder; }
			set {_displayorder= value; }
		}
		public  virtual IList<LocaleStringResource> LocaleStringResource
		{
			get { return _localestringresource; }
			set {_localestringresource= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			Language castObj = (Language)obj;
			return ( castObj != null ) &&
			this._languageid == castObj.LanguageId;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _languageid.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
