/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// LocaleStringResource object for NHibernate mapped table 'LocaleStringResource'.
	/// </summary>
	[Serializable]
	public class LocaleStringResource
	{
		#region Member Variables
		protected int _localestringresourceid;
		protected Language _language;
		protected string _resourcename;
		protected string _resourcevalue;
		#endregion
		#region Constructors
			
		public LocaleStringResource() {}
					
		public LocaleStringResource(Language language, string resourcename, string resourcevalue) 
		{
			this._language= language;
			this._resourcename= resourcename;
			this._resourcevalue= resourcevalue;
		}

		#endregion
		#region Public Properties
		public  virtual int LocaleStringResourceid
		{
			get { return _localestringresourceid; }
			set {_localestringresourceid= value; }
		}
		public  virtual Language Language
		{
			get { return _language; }
			set {_language= value; }
		}
		public  virtual string ResourceName
		{
			get { return _resourcename; }
			set {_resourcename= value; }
		}
		public  virtual string ResourceValue
		{
			get { return _resourcevalue; }
			set {_resourcevalue= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			LocaleStringResource castObj = (LocaleStringResource)obj;
			return ( castObj != null ) &&
			this._localestringresourceid == castObj.LocaleStringResourceid;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _localestringresourceid.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
