/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// Log object for NHibernate mapped table 'Log'.
	/// </summary>
	[Serializable]
	public class Log
	{
		#region Member Variables
		protected int _logid;
		protected int? _eventid;
		protected int _priority;
		protected string _severity;
		protected string _title;
		protected DateTime _timestamp;
		protected string _machinename;
		protected string _appdomainname;
		protected string _processid;
		protected string _processname;
		protected string _threadname;
		protected string _win32threadid;
		protected string _message;
		protected string _formattedmessage;
		#endregion
		#region Constructors
			
		public Log() {}
					
		public Log(int? eventid, int priority, string severity, string title, DateTime timestamp, string machinename, string appdomainname, string processid, string processname, string threadname, string win32threadid, string message, string formattedmessage) 
		{
			this._eventid= eventid;
			this._priority= priority;
			this._severity= severity;
			this._title= title;
			this._timestamp= timestamp;
			this._machinename= machinename;
			this._appdomainname= appdomainname;
			this._processid= processid;
			this._processname= processname;
			this._threadname= threadname;
			this._win32threadid= win32threadid;
			this._message= message;
			this._formattedmessage= formattedmessage;
		}

		public Log(int priority, string severity, string title, DateTime timestamp, string machinename, string appdomainname, string processid, string processname)
		{
			this._priority= priority;
			this._severity= severity;
			this._title= title;
			this._timestamp= timestamp;
			this._machinename= machinename;
			this._appdomainname= appdomainname;
			this._processid= processid;
			this._processname= processname;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Logid
		{
			get { return _logid; }
			set {_logid= value; }
		}
		public  virtual int? Eventid
		{
			get { return _eventid; }
			set {_eventid= value; }
		}
		public  virtual int Priority
		{
			get { return _priority; }
			set {_priority= value; }
		}
		public  virtual string Severity
		{
			get { return _severity; }
			set {_severity= value; }
		}
		public  virtual string Title
		{
			get { return _title; }
			set {_title= value; }
		}
		public  virtual DateTime Timestamp
		{
			get { return _timestamp; }
			set {_timestamp= value; }
		}
		public  virtual string MachineName
		{
			get { return _machinename; }
			set {_machinename= value; }
		}
		public  virtual string AppDomainName
		{
			get { return _appdomainname; }
			set {_appdomainname= value; }
		}
		public  virtual string Processid
		{
			get { return _processid; }
			set {_processid= value; }
		}
		public  virtual string ProcessName
		{
			get { return _processname; }
			set {_processname= value; }
		}
		public  virtual string ThreadName
		{
			get { return _threadname; }
			set {_threadname= value; }
		}
		public  virtual string Win32ThreadId
		{
			get { return _win32threadid; }
			set {_win32threadid= value; }
		}
		public  virtual string Message
		{
			get { return _message; }
			set {_message= value; }
		}
		public  virtual string FormattedMessage
		{
			get { return _formattedmessage; }
			set {_formattedmessage= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			Log castObj = (Log)obj;
			return ( castObj != null ) &&
			this._logid == castObj.Logid;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _logid.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
