/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// MasterInvalidReasons object for NHibernate mapped table 'MasterInvalidReasons'.
	/// </summary>
	[Serializable]
	public class MasterInvalidReasons
	{
		#region Member Variables
		protected int _id;
		protected string _reasonname;
		protected string _description;
		protected DateTime? _createddate;
		protected DateTime? _lastupdated;
		protected string _active;
		protected IList<CampaignPublisherResponse> _campaignpublisherresponse;
		#endregion
		#region Constructors
			
		public MasterInvalidReasons() {}
					
		public MasterInvalidReasons(string reasonname, string description, DateTime? createddate, DateTime? lastupdated, string active) 
		{
			this._reasonname= reasonname;
			this._description= description;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
			this._active= active;
		}

		public MasterInvalidReasons(string description)
		{
			this._description= description;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string ReasonName
		{
			get { return _reasonname; }
			set {_reasonname= value; }
		}
		public  virtual string Description
		{
			get { return _description; }
			set {_description= value; }
		}
		public  virtual DateTime? CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public  virtual string Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<CampaignPublisherResponse> CampaignPublisherResponse
		{
			get { return _campaignpublisherresponse; }
			set {_campaignpublisherresponse= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			MasterInvalidReasons castObj = (MasterInvalidReasons)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
