/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// MasterLocation object for NHibernate mapped table 'Master_Location'.
	/// </summary>
	[Serializable]
	public class MasterLocation
	{
		#region Member Variables
		protected int _id;
		protected string _location;
		protected DateTime _createddate;
		protected DateTime? _lastupdated;
		protected bool? _active;
		protected IList<CampaignAcctLocation> _campaignacctlocation;
		#endregion
		#region Constructors
			
		public MasterLocation() {}
					
		public MasterLocation(string location, DateTime createddate, DateTime? lastupdated, bool? active) 
		{
			this._location= location;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
			this._active= active;
		}

		public MasterLocation(string location, DateTime createddate)
		{
			this._location= location;
			this._createddate= createddate;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string Location
		{
			get { return _location; }
			set {_location= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public  virtual bool? Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<CampaignAcctLocation> CampaignAcctLocation
		{
			get { return _campaignacctlocation; }
			set {_campaignacctlocation= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			MasterLocation castObj = (MasterLocation)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
