/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// MasterTags object for NHibernate mapped table 'Master_Tags'.
	/// </summary>
	[Serializable]
	public class MasterTags
	{
		#region Member Variables
		protected int _id;
		protected string _tags;
		protected DateTime _createddate;
		protected DateTime? _lastupdated;
		protected IList<CampaignAcctTag> _campaignaccttag;
		#endregion
		#region Constructors
			
		public MasterTags() {}
					
		public MasterTags(string tags, DateTime createddate, DateTime? lastupdated) 
		{
			this._tags= tags;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
		}

		public MasterTags(string tags, DateTime createddate)
		{
			this._tags= tags;
			this._createddate= createddate;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string Tags
		{
			get { return _tags; }
			set {_tags= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public  virtual IList<CampaignAcctTag> CampaignAcctTag
		{
			get { return _campaignaccttag; }
			set {_campaignaccttag= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			MasterTags castObj = (MasterTags)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
