/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// PaymentInfo object for NHibernate mapped table 'PaymentInfo'.
	/// </summary>
	[Serializable]
	public class PaymentInfo
	{
		#region Member Variables
		protected int _idpaymentinfo;
		protected CreditCardType _creditcardtype;
		protected PaymentMethod _paymentmethod;
		protected string _cardname;
		protected string _cardnumber;
		protected string _maskedcreditcardnumber;
		protected string _cardcvv2;
		protected string _cardexpirationmonth;
		protected string _cardexpirationyear;
		protected IList<AdvertiserFunds> _advertiserfunds;
		protected IList<Campaign> _campaign;
		#endregion
		#region Constructors
			
		public PaymentInfo() {}
					
		public PaymentInfo(CreditCardType creditcardtype, PaymentMethod paymentmethod, string cardname, string cardnumber, string maskedcreditcardnumber, string cardcvv2, string cardexpirationmonth, string cardexpirationyear) 
		{
			this._creditcardtype= creditcardtype;
			this._paymentmethod= paymentmethod;
			this._cardname= cardname;
			this._cardnumber= cardnumber;
			this._maskedcreditcardnumber= maskedcreditcardnumber;
			this._cardcvv2= cardcvv2;
			this._cardexpirationmonth= cardexpirationmonth;
			this._cardexpirationyear= cardexpirationyear;
		}

		#endregion
		#region Public Properties
		public  virtual int IdPaymentInfo
		{
			get { return _idpaymentinfo; }
			set {_idpaymentinfo= value; }
		}
		public  virtual CreditCardType CreditCardType
		{
			get { return _creditcardtype; }
			set {_creditcardtype= value; }
		}
		public  virtual PaymentMethod PaymentMethod
		{
			get { return _paymentmethod; }
			set {_paymentmethod= value; }
		}
		public  virtual string CardName
		{
			get { return _cardname; }
			set {_cardname= value; }
		}
		public  virtual string CardNumber
		{
			get { return _cardnumber; }
			set {_cardnumber= value; }
		}
		public  virtual string MaskedCreditCardNumber
		{
			get { return _maskedcreditcardnumber; }
			set {_maskedcreditcardnumber= value; }
		}
		public  virtual string Cardcvv2
		{
			get { return _cardcvv2; }
			set {_cardcvv2= value; }
		}
		public  virtual string CardExpirationMonth
		{
			get { return _cardexpirationmonth; }
			set {_cardexpirationmonth= value; }
		}
		public  virtual string CardExpirationYear
		{
			get { return _cardexpirationyear; }
			set {_cardexpirationyear= value; }
		}
		public  virtual IList<AdvertiserFunds> AdvertiserFunds
		{
			get { return _advertiserfunds; }
			set {_advertiserfunds= value; }
		}
		public  virtual IList<Campaign> Campaign
		{
			get { return _campaign; }
			set {_campaign= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			PaymentInfo castObj = (PaymentInfo)obj;
			return ( castObj != null ) &&
			this._idpaymentinfo == castObj.IdPaymentInfo;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _idpaymentinfo.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
