/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// PaymentMethod object for NHibernate mapped table 'PaymentMethod'.
	/// </summary>
	[Serializable]
	public class PaymentMethod
	{
		#region Member Variables
		protected int _idpaymentmethod;
		protected string _name;
		protected string _visiblename;
		protected string _description;
		protected string _configuretemplatepath;
		protected string _usertemplatepath;
		protected string _classname;
		protected string _systemkeyword;
		protected bool _hidepaymentinfoforzeroorders;
		protected bool _isactive;
		protected int _displayorder;
		protected IList<PaymentInfo> _paymentinfo;
		protected IList<PaymentMethodRestrictedCountries> _paymentmethodrestrictedcountries;
		#endregion
		#region Constructors
			
		public PaymentMethod() {}
					
		public PaymentMethod(string name, string visiblename, string description, string configuretemplatepath, string usertemplatepath, string classname, string systemkeyword, bool hidepaymentinfoforzeroorders, bool isactive, int displayorder) 
		{
			this._name= name;
			this._visiblename= visiblename;
			this._description= description;
			this._configuretemplatepath= configuretemplatepath;
			this._usertemplatepath= usertemplatepath;
			this._classname= classname;
			this._systemkeyword= systemkeyword;
			this._hidepaymentinfoforzeroorders= hidepaymentinfoforzeroorders;
			this._isactive= isactive;
			this._displayorder= displayorder;
		}

		#endregion
		#region Public Properties
		public  virtual int IdPaymentMethod
		{
			get { return _idpaymentmethod; }
			set {_idpaymentmethod= value; }
		}
		public  virtual string Name
		{
			get { return _name; }
			set {_name= value; }
		}
		public  virtual string VisibleName
		{
			get { return _visiblename; }
			set {_visiblename= value; }
		}
		public  virtual string Description
		{
			get { return _description; }
			set {_description= value; }
		}
		public  virtual string ConfigureTemplatePath
		{
			get { return _configuretemplatepath; }
			set {_configuretemplatepath= value; }
		}
		public  virtual string UserTemplatePath
		{
			get { return _usertemplatepath; }
			set {_usertemplatepath= value; }
		}
		public  virtual string ClassName
		{
			get { return _classname; }
			set {_classname= value; }
		}
		public  virtual string SystemKeyword
		{
			get { return _systemkeyword; }
			set {_systemkeyword= value; }
		}
		public  virtual bool HidePaymentInfoForZeroOrders
		{
			get { return _hidepaymentinfoforzeroorders; }
			set {_hidepaymentinfoforzeroorders= value; }
		}
		public  virtual bool IsActive
		{
			get { return _isactive; }
			set {_isactive= value; }
		}
		public  virtual int DisplayOrder
		{
			get { return _displayorder; }
			set {_displayorder= value; }
		}
		public  virtual IList<PaymentInfo> PaymentInfo
		{
			get { return _paymentinfo; }
			set {_paymentinfo= value; }
		}
		public  virtual IList<PaymentMethodRestrictedCountries> PaymentMethodRestrictedCountries
		{
			get { return _paymentmethodrestrictedcountries; }
			set {_paymentmethodrestrictedcountries= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			PaymentMethod castObj = (PaymentMethod)obj;
			return ( castObj != null ) &&
			this._idpaymentmethod == castObj.IdPaymentMethod;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _idpaymentmethod.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
