/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// RecurringPayment object for NHibernate mapped table 'RecurringPayment'.
	/// </summary>
	[Serializable]
	public class RecurringPayment
	{
		#region Member Variables
		protected int _recurringpaymentid;
		protected int _initialorderid;
		protected int _cyclelength;
		protected int _cycleperiod;
		protected int _totalcycles;
		protected DateTime _startdate;
		protected bool _isactive;
		protected bool _deleted;
		protected DateTime _createdon;
		protected IList<RecurringPaymentHistory> _recurringpaymenthistory;
		#endregion
		#region Constructors
			
		public RecurringPayment() {}
					
		public RecurringPayment(int recurringpaymentid, int initialorderid, int cyclelength, int cycleperiod, int totalcycles, DateTime startdate, bool isactive, bool deleted, DateTime createdon) 
		{
			this._recurringpaymentid= recurringpaymentid;
			this._initialorderid= initialorderid;
			this._cyclelength= cyclelength;
			this._cycleperiod= cycleperiod;
			this._totalcycles= totalcycles;
			this._startdate= startdate;
			this._isactive= isactive;
			this._deleted= deleted;
			this._createdon= createdon;
		}

		#endregion
		#region Public Properties
		public  virtual int RecurringPaymentid
		{
			get { return _recurringpaymentid; }
			set {_recurringpaymentid= value; }
		}
		public  virtual int InitialOrderid
		{
			get { return _initialorderid; }
			set {_initialorderid= value; }
		}
		public  virtual int CycleLength
		{
			get { return _cyclelength; }
			set {_cyclelength= value; }
		}
		public  virtual int CyclePeriod
		{
			get { return _cycleperiod; }
			set {_cycleperiod= value; }
		}
		public  virtual int TotalCycles
		{
			get { return _totalcycles; }
			set {_totalcycles= value; }
		}
		public  virtual DateTime StartDate
		{
			get { return _startdate; }
			set {_startdate= value; }
		}
		public  virtual bool IsActive
		{
			get { return _isactive; }
			set {_isactive= value; }
		}
		public  virtual bool Deleted
		{
			get { return _deleted; }
			set {_deleted= value; }
		}
		public  virtual DateTime CreatedOn
		{
			get { return _createdon; }
			set {_createdon= value; }
		}
		public  virtual IList<RecurringPaymentHistory> RecurringPaymentHistory
		{
			get { return _recurringpaymenthistory; }
			set {_recurringpaymenthistory= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			RecurringPayment castObj = (RecurringPayment)obj;
			return ( castObj != null ) &&
			this._recurringpaymentid == castObj.RecurringPaymentid;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _recurringpaymentid.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
