/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// TransType object for NHibernate mapped table 'TransType'.
	/// </summary>
	[Serializable]
	public class TransType
	{
		#region Member Variables
		protected int _id;
		protected string _type;
		protected DateTime _createddate;
		protected string _remarks;
		protected bool _active;
		protected IList<AdvertiserFunds> _advertiserfunds;
		#endregion
		#region Constructors
			
		public TransType() {}
					
		public TransType(string type, DateTime createddate, string remarks, bool active) 
		{
			this._type= type;
			this._createddate= createddate;
			this._remarks= remarks;
			this._active= active;
		}

		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string Type
		{
			get { return _type; }
			set {_type= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual string Remarks
		{
			get { return _remarks; }
			set {_remarks= value; }
		}
		public  virtual bool Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<AdvertiserFunds> AdvertiserFunds
		{
			get { return _advertiserfunds; }
			set {_advertiserfunds= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			TransType castObj = (TransType)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
