/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model
{
	/// <summary>
	/// WithdrawlMethod object for NHibernate mapped table 'Withdrawl_Method'.
	/// </summary>
	[Serializable]
	public class WithdrawlMethod
	{
		#region Member Variables
		protected int _id;
		protected string _withdrawlmethodmember;
		protected string _description;
		protected DateTime _createddate;
		protected bool _active;
		protected IList<PublisherWithdraw> _publisherwithdraw;
		#endregion
		#region Constructors
			
		public WithdrawlMethod() {}
					
		public WithdrawlMethod(string withdrawlmethodmember, string description, DateTime createddate, bool active) 
		{
			this._withdrawlmethodmember= withdrawlmethodmember;
			this._description= description;
			this._createddate= createddate;
			this._active= active;
		}

		public WithdrawlMethod(string withdrawlmethodmember, DateTime createddate, bool active)
		{
			this._withdrawlmethodmember= withdrawlmethodmember;
			this._createddate= createddate;
			this._active= active;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string WithdrawlMethodMember
		{
			get { return _withdrawlmethodmember; }
			set {_withdrawlmethodmember= value; }
		}
		public  virtual string Description
		{
			get { return _description; }
			set {_description= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual bool Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<PublisherWithdraw> PublisherWithdraw
		{
			get { return _publisherwithdraw; }
			set {_publisherwithdraw= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			WithdrawlMethod castObj = (WithdrawlMethod)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
