/*
using MyGeneration/Template/NHibernate (c) by lujan99@usa.net
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace SND.Model.SocialAccounts
{
	/// <summary>
	/// Account object for NHibernate mapped table 'Account'.
	/// </summary>
	[Serializable]
	public class SocialAccount
	{
		#region Member Variables
		protected int _id;
		protected string _name;
		protected decimal _chargeamount;
		protected DateTime _createddate;
		protected DateTime? _lastupdated;
		protected bool? _active;
        //protected IList<CampaignAccount> _campaignaccount;
        //protected IList<CampaignAcctLocation> _campaignacctlocation;
        //protected IList<CampaignAcctTag> _campaignaccttag;
        //protected IList<CampaignPublisher> _campaignpublisher;
        //protected IList<CampaignPublisherResponse> _campaignpublisherresponse;
		#endregion
		#region Constructors
			
		public SocialAccount() {}
					
		public SocialAccount(string name, decimal chargeamount, DateTime createddate, DateTime? lastupdated, bool? active) 
		{
			this._name= name;
			this._chargeamount= chargeamount;
			this._createddate= createddate;
			this._lastupdated= lastupdated;
			this._active= active;
		}

		public SocialAccount(string name, decimal chargeamount, DateTime createddate)
		{
			this._name= name;
			this._chargeamount= chargeamount;
			this._createddate= createddate;
		}
		
		#endregion
		#region Public Properties
		public  virtual int Id
		{
			get { return _id; }
			set {_id= value; }
		}
		public  virtual string Name
		{
			get { return _name; }
			set {_name= value; }
		}
		public  virtual decimal ChargeAmount
		{
			get { return _chargeamount; }
			set {_chargeamount= value; }
		}
		public  virtual DateTime CreatedDate
		{
			get { return _createddate; }
			set {_createddate= value; }
		}
		public  virtual DateTime? LastUpdated
		{
			get { return _lastupdated; }
			set {_lastupdated= value; }
		}
		public  virtual bool? Active
		{
			get { return _active; }
			set {_active= value; }
		}
		public  virtual IList<CampaignAccount> CampaignAccount
		{
			get { return _campaignaccount; }
			set {_campaignaccount= value; }
		}
		public  virtual IList<CampaignAcctLocation> CampaignAcctLocation
		{
			get { return _campaignacctlocation; }
			set {_campaignacctlocation= value; }
		}
		public  virtual IList<CampaignAcctTag> CampaignAcctTag
		{
			get { return _campaignaccttag; }
			set {_campaignaccttag= value; }
		}
		public  virtual IList<CampaignPublisher> CampaignPublisher
		{
			get { return _campaignpublisher; }
			set {_campaignpublisher= value; }
		}
		public  virtual IList<CampaignPublisherResponse> CampaignPublisherResponse
		{
			get { return _campaignpublisherresponse; }
			set {_campaignpublisherresponse= value; }
		}
		#endregion
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			if( ( obj == null ) || ( obj.GetType() != this.GetType() ) ) return false;
			SocialAccount castObj = (SocialAccount)obj;
			return ( castObj != null ) &&
			this._id == castObj.Id;
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
			int hash = 57;
			hash = 27 * hash * _id.GetHashCode();
			return hash;
		}
		#endregion
		
	}
}
